import numpy as np

B = np.array( [[1, 1, 1],
               [1, 2, 1],
               [2, 2, 0.5] ] )

b = np.array( [ [1],
                [2],
                [1] ] )

# A x = b
# x = inv(A) b

x = np.linalg.inv( B ) @ b

print( x )

######################
# usando la descomposición QR

A = np.concatenate( (B, b), axis=1 )


R = np.linalg.qr( A, mode='r' )
print( R )

# [ r11 r12 r13 ][x1]   [v1]
# [   0 r22 r23 ][x2] = [v2]
# [   0   0 r33 ][x3]   [v3]
#
# r22 x2 + r23 x3 = v2 
# x2 = (v2 - r23 x3)/r22


n = 2

vx = np.zeros( (n+1,) )

vx[n] = R[n,n+1] / R[n,n]
k = n-1
while k >= 0 :
	suma = 0.0
	i = k+1
	while i <= n :
		suma += R[k,i]*vx[i]
		i += 1
	vx[k] = (R[k,n+1] - suma)/R[k,k]
	k -= 1

print( vx ) 
