import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.linear_model import Ridge

# Leo los datos
D = np.loadtxt( "datos.txt" )
print( D.shape )

n, m = D.shape

# Construimos la matriz del modelo
# Para un parámetro (una linea)
# Para dos parámetros  x^2 x
# Para tres parámetros  x^3 x^2 x

# Para ajustar a un polinomio de orden 9
X = np.ones( (n, 9) )

X[:,8] = D[:,0]                      # x
X[:,7] = D[:,0] * D[:,0]             # x^2
X[:,6] = D[:,0] * D[:,0] * D[:,0]    # x^3
X[:,5] = X[:,7]*X[:,7]               # x^4
X[:,4] = X[:,6]*X[:,7]               # x^5
X[:,3] = X[:,6]*X[:,6]               # x^6
X[:,2] = X[:,3]*X[:,8]               # x^7
X[:,1] = X[:,5]*X[:,5]               # x^8       
X[:,0] = X[:,5]*X[:,4]               # x^9

# Separamos los datos en datos de entrenamiento
# y datos de prueba
#
X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, D[:,1], random_state=2 )

regresor = Ridge( alpha=10.0 )
regresor.fit(X_entrena, y_entrena)
r2 = regresor.score(X_prueba, y_prueba)
print( r2 )

print( regresor.coef_ )
print( regresor.intercept_ )

